var doc = null;
function readXML() {
    if (window.XMLHttpRequest)
    {
        xhttp = new XMLHttpRequest();
    }
    else // Internet Explorer 5/6
    {
        xhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
    xhttp.open("GET", "data.xml", false);
    xhttp.send("");
    var xmlDoc = xhttp.responseXML;
}
// Create a new Document object. If no arguments are specified,
// the document will be empty. If a root tag is specified, the document
// will contain that single root tag. If the root tag has a namespace
// prefix, the second argument must specify the URL that identifies the
// namespace.

function newXML(rootTagName, namespaceURL) {
    if (!rootTagName) rootTagName = "";
    if (!namespaceURL) namespaceURL = "";
    if (document.implementation && document.implementation.createDocument) {
        // This is the W3C standard way to do it
        return document.implementation.createDocument(namespaceURL, rootTagName, null);
    }
    else { // This is the IE way to do it
        // Create an empty document as an ActiveX object
        // If there is no root element, this is all we have to do
        var doc = new ActiveXObject("MSXML2.DOMDocument");
        // If there is a root tag, initialize the document
        if (rootTagName) {
            // Look for a namespace prefix
            var prefix = "";
            var tagname = rootTagName;
            var p = rootTagName.indexOf(':');
            if (p != -1) {
                prefix = rootTagName.substring(0, p);
                tagname = rootTagName.substring(p + 1);
            }
            // If we have a namespace, we must have a namespace prefix
            // If we don't have a namespace, we discard any prefix
            if (namespaceURL) {
                if (!prefix) prefix = "a0"; // What Firefox uses
            }
            else prefix = "";
            // Create the root element (with optional namespace) as a
            // string of text
            var text = "<" + (prefix ? (prefix + ":") : "") + tagname +
                       (namespaceURL
                               ? (" xmlns:" + prefix + '="' + namespaceURL + '"')
                               : "") +
                       "/>";
            // And parse that text into the empty document
            doc.loadXML(text);
        }
        //doc.version = "1.0";
        //doc.encoding ="UTF-8";
        return doc;
    }
}
function addNode(data) {
    var elem = doc.createElement(data.nodeName);
    if (data.attributes != null) {
        for (var i = 0; i < data.attributes.length; i++) {
            if (data.attributes[i].value != "" && data.attributes[i].value != "undefined" && data.attributes[i].value != "select") {
                elem.setAttribute(data.attributes[i].name, data.attributes[i].value);
            }
        }
    }
    if (data.data != null) {
        elem.appendChild(doc.createTextNode(data.data))
    }
    return elem;
}
var xmlToStingFirstTime = true;
function xmlToString(xmlObj) {
    var str = "";
    if (navigator.appName == "Netscape")
    {
        str= (new XMLSerializer()).serializeToString(xmlObj);
    }
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        str = xmlObj.xml;
    }
    if(xmlToStingFirstTime){
        //str = '<?xml version="1.0" encoding="UTF-8"?>'+str;
        xmlToStingFirstTime = false;
    }
    return str;
}
function getNodeByPath(path) {
    var subItems = doc.getElementsByTagName("*");
    var toReturn = null;
    for (var i = 0; i < subItems.length; i++) {
        if (subItems[i].getAttribute('path') == path) toReturn = subItems[i];
    }
    return toReturn;
}
function getNodeById(id) {
    var subItems = doc.getElementsByTagName("*");
    var toReturn = null;
    for (var i = 0; i < subItems.length; i++) {
        if (subItems[i].getAttribute('id') == id) toReturn = subItems[i];
    }
    return toReturn;
}
function getNodeByName(name) {
    var subItems = doc.getElementsByTagName("*");
    var toReturn = null;
    for (var i = 0; i < subItems.length; i++) {
        if (subItems[i].getAttribute('name') == name) toReturn = subItems[i];
    }
    return toReturn;
}
function addNewNodeToTree(nodeText,nodeId,idprefix) {
    //Create the html tree thing
    cleanSelected();
    if (tmpSelected != null) {
        var selectedChoice = tmpSelected;
    } else {
        selectedChoice = selected;
    }
    var theUL = null;
    for (var i = 0; i < selectedChoice.parentNode.childNodes.length; i++) {
        if (selectedChoice.parentNode.childNodes[i].nodeName == "UL") {
            theUL = selectedChoice.parentNode.childNodes[i];
        }
    }

    var newNode = document.createElement("LI");
    newNode.innerHTML = '<a class="nodata" onclick="treeColapse(this)">&nbsp;</a> <a id="' + idprefix +'_' + nodeId + '" class="treeNode selected '+idprefix+'" onclick="selectNode(this)">' + nodeText + '</a>';
    if(idprefix == "coq"){
        newNode.innerHTML = '<a class="nodata" onclick="treeColapse(this)">&nbsp;</a> <a id="' + idprefix +'_' + nodeId + '" class="treeNode selected '+idprefix+'" onclick="selectNode(this)">' + nodeText + '</a><a class="moveNode" id="moveNode'+nodeId+'">&nbsp</a>';        
    }
    if (theUL != null) {
        theUL.appendChild(newNode);
    } else {
        theUL = document.createElement("UL");
        theUL.appendChild(newNode);
        selectedChoice.parentNode.appendChild(theUL);
        YAHOO.util.Dom.removeClass(selectedChoice.parentNode.childNodes[0], "nodata");
        YAHOO.util.Dom.addClass(selectedChoice.parentNode.childNodes[0], "minus");
    }

    //Register event for right click for the newly added node

    Event.onAvailable(idprefix + '_' + nodeId, function() {

        Event.addListener(idprefix + '_' + nodeId, 'contextmenu', handle, true);

    });

    return idprefix+"_" + nodeId;

}
function clearTempSelected(){
    if(tmpSelected== null){
        return;
    }
    if( tmpSelected.parentNode.parentNode.nodeName == "UL"){
        if(tmpSelected.parentNode.parentNode.childNodes.length<2){
            tmpSelected.parentNode.parentNode.parentNode.removeChild(tmpSelected.parentNode.parentNode);
        }else{
            tmpSelected.parentNode.parentNode.removeChild(tmpSelected.parentNode);
        }
    }
    cleanSelected();
    if(!YAHOO.util.Dom.hasClass(selected, "selected")){
        YAHOO.util.Dom.addClass(selected, "selected");
    }
    tmpSelected = null;
}
function setJDBCValues(selectedValue) {
    var dsForm = document.dsConfig;
    var jdbcUrl = selectedValue.substring(0, selectedValue.indexOf("#"));
    var driverClass = selectedValue.substring(selectedValue.indexOf("#") + 1, selectedValue.length);
    dsForm.dsProtocol.value = jdbcUrl;
    dsForm.dsDriver.value = driverClass;
}
function showConfigForm(form){
    var configForms = document.getElementById("configForms");
    var connectionTester = document.getElementById("connectionTester");
    var configFormsChilds = configForms.getElementsByTagName("TABLE");
    for(var i = 0;i<configFormsChilds.length;i++){
        configFormsChilds[i].style.display = "none";
    }
    connectionTester.style.display ="none";
    if(form != "select"){
        document.getElementById(form+"_table").style.display = "";
        if(form == "RDBMS"){
            connectionTester.style.display = "";
        }
    }
}
function brakeColumns(query) {
    var columnList = new Array();
    var patten1 = /^[a-zA-Z\$_][a-zA-Z0-9]*/i;
    var patten2 = /^[a-zA-Z\$_][a-zA-Z0-9]*\.[a-zA-Z\$_][a-zA-Z0-9]*$/i;
    var numEnd = query.search(/\sfrom\s/i);
    var elems = (query.substring(6, numEnd)).split(",");
    for (var i = 0; i < elems.length; i++) {
        var elem = elems[i].toString();
        elem = trim(elem);
        var stPoint = "";
        var wanted = "";
        if (elem.search(/\sas\s/i) != -1) {
            stPoint = elem.search(/\sas\s/i);
            wanted = elem.substring(stPoint + 4);
            wanted = trim(wanted);
            if (patten1.test(wanted)) {
                columnList.push(wanted);
            }
        } else if (patten2.test(elem)) {   //check for tablename.column name pattern
            stPoint = elem.search(/\./);
            wanted = elem.substring(stPoint + 1);
            wanted = trim(wanted);
            if (patten1.test(wanted)) {
                columnList.push(wanted);
            }
        } else {   //check for straight column name like username,passsword etc
            if (patten1.test(elem)) {
                columnList.push(elem);
            }
        }
    }
    return(columnList);
}


function trim(stringToTrim) {
    return stringToTrim.replace(/^\s+|\s+$/g, "");
}
function ltrim(stringToTrim) {
    return stringToTrim.replace(/^\s+/, "");
}
function rtrim(stringToTrim) {
    return stringToTrim.replace(/\s+$/, "");
}
function spaces(len)
{
	var s = '';
	var indent = len*4;
	for (i=0;i<indent;i++) {s += " ";}

	return s;
}
function removeNL(s){
    var rs=s;
    rs = s.replace(/[\n\r\t]/g,"");
    rs = rs.replace(/(>)\s+(<)/,"");
    return rs;
}

function format_xml(str)
{
	var xml = '';

	// add newlines
	str = str.replace(/(>)(<)(\/*)/g,"$1\r$2$3");

	// add indents
	var pad = 0;
	var indent;
	var node;

	// split the string
	var strArr = str.split("\r");

	// check the various tag states
	for (var i = 0; i < strArr.length; i++) {
		indent = 0;
		node = strArr[i];

		if(node.match(/.+<\/\w[^>]*>$/)){ //open and closing in the same line
			indent = 0;
		} else if(node.match(/^<\/\w/)){ // closing tag
			if (pad > 0){pad -= 1;}
		} else if (node.match(/^<\w[^>]*[^\/]>.*$/)){ //opening tag
			indent = 1;
		} else
			indent = 0;
		//}

		xml += spaces(pad) + node + "\r";
		pad += indent;
	}
    xml = xml.replace(/(&gt;)/g, ">");
    xml = xml.replace(/(&lt;)/g, "<");
	return xml;
}
function convertToValidXMlString(originalStr) {
    //Replace all the correct code with invalid code
    var convertedStr = relpaceString(originalStr, "&amp;", "&");
    convertedStr = relpaceString(convertedStr, "&lt;", "<");
    convertedStr = relpaceString(convertedStr, "&gt;", ">");
    convertedStr = relpaceString(convertedStr, "&quot;", '"');
    //    convertedStr = relpaceString(convertedStr, "&#39;", "'");

    //Replace all the invalid code with correct code
    convertedStr = relpaceString(convertedStr, "&", "&amp;");
    convertedStr = relpaceString(convertedStr, "<", "&lt;");
    convertedStr = relpaceString(convertedStr, ">", "&gt;");
    convertedStr = relpaceString(convertedStr, '"', "&quot;");
    //    convertedStr = relpaceString(convertedStr, "'", "&#39;");
    return convertedStr;

}

function str2xml(strXML) {
    if (window.ActiveXObject)
    {
        var newdoc = new ActiveXObject("Microsoft.XMLDOM");
        newdoc.async = "false";
        newdoc.loadXML(strXML);
    }
    // code for Mozilla, Firefox, Opera, etc.
    else
    {
        var parser = new DOMParser();
        var newdoc = parser.parseFromString(strXML, "text/xml");
    }// documentElement always represents the root node
    return newdoc;
}

function relpaceString(originalStr, originalword, relaceword) {
    if (originalStr == undefined || originalStr == null) {
        return null;
    }
   return originalStr.replace(originalword,relaceword);
}
function nextObject(obj) {
    var n = obj;
    do n = n.nextSibling;
    while (n && n.nodeType != 1);
    return n;
}
function countlines(txt) {
    var xmlEditorValue = editAreaLoader.getValue("xmlEditor");
    var searchExp = new RegExp(txt);
    var lineArray = new Array();
    if(xmlEditorValue.search(searchExp,txt) != -1){
        var firstString = xmlEditorValue.substring(0,xmlEditorValue.search(searchExp,txt));
        lineArray = firstString.split("\n");
    }
    return lineArray.length;
}
/*
This is for displaying info and error messages for dataservices
 */
function showDsTreeMessages(message,msgtype) {
    if(msgtype == const_error){
        CARBON.showErrorDialog(message);
    }else if(msgtype == const_info){
        CARBON.showInfoDialog(message);
    }
    /*var dsTreeMessages = Dom.get("dsTreeMessages");
    if(Dom.hasClass(dsTreeMessages,"dsTreeMessages-info")){
        Dom.removeClass(dsTreeMessages,"dsTreeMessages-info");
    }else if(Dom.hasClass(dsTreeMessages,"dsTreeMessages-error")){
        Dom.removeClass(dsTreeMessages,"dsTreeMessages-error");
    }

    Dom.addClass(dsTreeMessages,"dsTreeMessages-"+msgtype); // add the message icon base on error type

    Dom.setStyle(['dsTreeMessages'], 'opacity', "1");  //set all the style back to normal when the message box comes for a second time
    Dom.setStyle(['dsTreeMessages'], 'height', "20px");
    dsTreeMessages.style.display = "";
    dsTreeMessages.innerHTML = message;
    setTimeout(function() {
        var attributes = {
            opacity: { to: 0 },
            height: { to: 0 }
        };
        var anim = new YAHOO.util.Anim(dsTreeMessages, attributes);
        anim.duration = 0.3;
        anim.onComplete.subscribe(function(){
            dsTreeMessages.style.display = "none";
        }, dsTreeMessages);
        anim.animate();
    }, 5000);*/
}

/*
delete all table rows for a given table
 */
function deleteTableRows(tl,keepHeader){
    if(typeof(tl) != "object"){
        tl = Dom.get(tl);
    }
    //debugger;
    for(var i = tl.rows.length;tl.rows.length>0;i--)
    {
        if(tl.rows.length>1){
            tl.deleteRow(tl.rows.length-1);
        }
        if(tl.rows.length==1){
            if(!keepHeader){
                tl.deleteRow(0);
            }
            return;
        }
    }

}