function validateEmpty(inputElement) {
    var txt = inputElement;
    if(typeof(inputElement)== "object"){
        var txt = inputElement.value;
    }
    var noError = true;
    if (trim(txt) == "") {
        noError = false;
    }
    return noError;
}
function validateMain(){
    var dsForm = document.dsMain;
    var error = "";

    if(dsForm.batchResponse[0].checked && dsForm.sessionType[dsForm.sessionType.selectedIndex].value == "select"){
        error += "When Enable Batch Response is \"ture\" please select a session type";  
    }
    if(error == ""){
        return true;
    } else {
        showDsTreeMessages(error,const_error);
        return false;
    }
}
function validateConfig(){
    var dsForm = document.dsConfig;
    var error = "";
    var dsId = dsForm.dsId;
    var datasourceType = dsForm.datasourceType[dsForm.datasourceType.selectedIndex].value;
    var databaseEngine = dsForm.databaseEngine[dsForm.databaseEngine.selectedIndex].value;
    if(!validateEmpty(dsId)){
        error += 'Field "DataSource Id" is empty,  ';
    }
    if(datasourceType=="select"){
        error += 'Field "DataSource Type" is not selected, ';
    }else if(datasourceType==rdbms){
        if (databaseEngine == "select") {
            error += 'Field "Database Engine" is not selected, ';
        }else {
            if (!validateEmpty(dsForm.dsDriver.value)) {
                error += 'Field "Driver Class" is empty, ';
            }
            if (!validateEmpty(dsForm.dsProtocol.value)) {
                error += 'Field "JDBC URL" is empty, ';
            }
            if (!validateEmpty(dsForm.dsUser.value)) {
                error += 'Field "Username" is empty, ';
            }
            if (!validateEmpty(dsForm.dsPassword.value)) {
                error += 'Field "Password" is empty, ';
            }
        }
    }else if(datasourceType==csv){
        if (!validateEmpty(dsForm.csv_datasource.value)) {
            error += 'Field "CSV File Location" is empty, ';
        }
        if (!validateEmpty(dsForm.csv_columnseperator.value)) {
            error += 'Field "Column Seperator" is empty, ';
        }
    }else if(datasourceType == excel){
        if (!validateEmpty(dsForm.excel_datasource.value)) {
            error += 'Field "EXCEL File Location" is empty, ';
        }    
    }else if(datasourceType == jndi){
        if (!validateEmpty(dsForm.excel_datasource.value)) {
            error += 'Field "JNDI Context Class" is empty, ';
        }
        if (!validateEmpty(dsForm.jndi_provider_url.value)) {
            error += 'Field "Provider URL" is empty, ';
        }
        if (!validateEmpty(dsForm.jndi_resource_name.value)) {
            error += 'Field "Resource Name" is empty, ';
        }
        if (!validateEmpty(dsForm.jndi_username.value)) {
            error += 'Field "User Name" is empty, ';
        }
        if (!validateEmpty(dsForm.dsJNDI_contextClass.value)) {
            error += 'Field "Password" is empty, ';
        }
    }else if(datasourceType == gspread){
        if (!validateEmpty(dsForm.gspread_datasource.value)) {
            error += 'Field "Google Spreadsheet URL" is empty, ';
        }
    }else if(datasourceType == carbon){
        if (!validateEmpty(dsForm.carbonDataSourceName.value)) {
            error += 'Field "Data Source Name" is empty, ';
        }
    }

    if(error == ""){
        return true;
    } else {
        showDsTreeMessages(error,const_error);
        return false;
    }
}
function validateQueryInputMapping() {
     var error = "";

    //finding the request (input parm)
    var request = Dom.get("queryForm_reqmap_form").childNodes;

    for (var i = 0; i < request.length; i++) {
        if (request[i] != null && request[i].nodeName == "TR") {
            var requestChilds = request[i].getElementsByTagName("*");

            for (var j = 0; j < requestChilds.length; j++) {
                if (requestChilds[j].getAttribute("name") == "inputMappingNameId") {
                    var inputMappingNameId = requestChilds[j].value;
                } else if (requestChilds[j].getAttribute("name") == "paramType") {
                    var paramType = requestChilds[j].value;
                } else if (requestChilds[j].getAttribute("name") == "sqlType") {
                    var sqlType = requestChilds[j].value;
                } else if (requestChilds[j].getAttribute("name") == "defaultValue") {
                    var defaultValue = requestChilds[j].value;
                } else if (requestChilds[j].getAttribute("name") == "inputMappingInOutType") {
                    var inputMappingInOutType = requestChilds[j].value;
                } else if (requestChilds[j].getAttribute("name") == "inputMappingOrdinal") {
                    var inputMappingOrdinal = requestChilds[j].value;
                }
            }
            if(!validateEmpty(inputMappingNameId)){
                error += "Mapping Name field is empty";
            }else if(!validateEmpty(sqlType)){
                error += "SQL Type field is empty";
            }
        }
    }
    if(error == ""){
        return true;
    } else {
        showDsTreeMessages(error,const_error);
        return false;
    }

}
function validateOperation() {
    var dsForm = document.dsOperation;
    var error = "";


    if(dsForm.queryId.selectedIndex == -1){
        error += 'There are no queries created yet. You need to have at least one query to create an operation';
    }else{
        if(!validateEmpty(dsForm.dsName.value)){
            error += '"Operation Name" field is empty,';
        }
    }
    if(error == ""){
        return true;
    } else {
        showDsTreeMessages(error,const_error);
        return false;
    }
}
function validateResource() {
    var dsForm = document.dsResource;
    var error = "";


    if(dsForm.queryId.selectedIndex == -1){
        error += 'There are no queries created yet. You need to have at least one query to create a resource';
    }else{
        if(!validateEmpty(dsForm.resourcePath.value)){
            error += '"Resource Path" field is empty,';
        }
    }
    if(error == ""){
        return true;
    } else {
        showDsTreeMessages(error,const_error);
        return false;
    }
}
function validateEvent() {
    var dsForm = document.dsEvent;
    var error = "";

    if (!validateEmpty(dsForm.evnetId.value)) {
        error += '"Event Id" field is empty,';
    }
    if (!validateEmpty(dsForm.expression.value)) {
        error += '"Expression" field is empty,';
    }
    if (!validateEmpty(dsForm.targetTopic.value)) {
        error += '"Target Topic" field is empty,';
    }

    //Detect for subscription page empty fields
    var hasSubscriptionError = false;
    var subsTable = Dom.get("subscriptionTable");
    var subsTableRows = subsTable.childNodes;
    for(var i=0;i<subsTableRows.length;i++){
        var currentRow = subsTableRows[i];
        if(currentRow.nodeName == "TR"){
            if(!validateEmpty(currentRow.childNodes[0].childNodes[0].value)){
                hasSubscriptionError = true;
            }
        }
    }
    if (hasSubscriptionError) {
        error += 'One or more "Subscription" fields are empty,';
    }
    

    if (error == "") {
        return true;
    } else {
        showDsTreeMessages(error,const_error);
        return false;
    }
}
function validateProps(){
    var dsForm = document.dsQuery;
    var error = "";

    if(!validateEmpty(dsForm.timeout.value)){
        error += "Timeout is empty";
    }
    if(dsForm.fetchDirection[dsForm.fetchDirection.selectedIndex].value == "select"){
        error += "Please select a Fetch Direction";
    }
    if(!validateEmpty(dsForm.fetchSize.value)){
        error += "Fetch Size is empty";
    }
    if(!validateEmpty(dsForm.maxFieldSize.value)){
        error += "Max Field Size is empty";
    }
    if(!validateEmpty(dsForm.maxRows.value)){
        error += "Max Rows is empty";
    }
    if(error == ""){
        return true;
    } else {
        showDsTreeMessages(error,const_error);
        return false;
    }
}